package org.leedberg.cotiro;

/*
Cotiro 0.7.7
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2008, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

public class Days {
	protected boolean Mon;

	protected boolean Tue;

	protected boolean Wed;

	protected boolean Thu;

	protected boolean Fri;
        
        protected boolean Sat;
        
        protected boolean Sun;

	public Days() {
		Mon = Tue = Wed = Thu = Fri = Sat = Sun = true;
	}

	public Days(String days) {
		Mon = days.indexOf("M") > -1 ? true : false;

		Tue = days.indexOf("T") > -1 ? true : false;

		Wed = days.indexOf("W") > -1 ? true : false;

		Thu = days.indexOf("H") > -1 ? true : false;

		Fri = days.indexOf("F") > -1 ? true : false;
                
                Sat = days.indexOf("S") > -1 ? true : false;
                
                Sun = days.indexOf("U") > -1 ? true : false;
	}

	public Days(boolean Mon, boolean Tue, boolean Wed, boolean Thu, boolean Fri, boolean Sat, boolean Sun) {
		this.Mon = Mon;
		this.Tue = Tue;
		this.Wed = Wed;
		this.Thu = Thu;
		this.Fri = Fri;
                this.Sat = Sat;
                this.Sun = Sun;                        
	}

	public String toString() {
		String retVal = "";

		retVal += (Mon ? "M" : "") + (Tue ? "T" : "") + (Wed ? "W" : "")
				+ (Thu ? "H" : "") + (Fri ? "F" : "") 
                                + (Sat ? "S" : "") + (Sun ? "U" : "");

		return retVal;
	}

	// Returns true if there is any overlap between days
	public boolean overlaps(Days d) {
		return ((Mon && d.Mon) || (Tue && d.Tue) || (Wed && d.Wed)
				|| (Thu && d.Thu) || (Fri && d.Fri)
                                || (Sat && d.Sat) || (Sun && d.Sun));
	}

	// Returns true if the days in "d" are a subset of the days in
	// this object
	public boolean encompasses(Days d) {
		// Basically, what this equation does is, for each
		// day, if d does not contain that day, we get a "true".
		// if d DOES contain that day, we get a true iff this object
		// also contains that day. We then AND all of these together.
		// The only falses should come from days that are in d, but
		// not in this object. If there are any of those, then
		// this object does not encompass d, and we get a false
		// from the AND. Get it?
		return (d.Mon ? d.Mon == Mon : true) 
                                && (d.Tue ? d.Tue == Tue : true)
				&& (d.Wed ? d.Wed == Wed : true)
				&& (d.Thu ? d.Thu == Thu : true)
				&& (d.Fri ? d.Fri == Fri : true)
                                && (d.Sat ? d.Sat == Sat : true)
                                && (d.Sun ? d.Sun == Sun : true);
	}

        public static boolean isValid(String days) {
            // Returns true if this string contains only valid day characters
            String validCharacters = "MTWHFSU";
            for (int i = 0; i < days.length(); i++) {
                if (!(validCharacters.indexOf(days.charAt(i)) >= 0)) {
                    return false;
                }
            }
            
            return true;
        }
        
        public boolean hasMon() {
            return this.Mon;
        }
        
        public boolean hasTue() {
            return this.Tue;
        }
        
        public boolean hasWed() {
            return this.Wed;
        }
        
        public boolean hasThu() {
            return this.Thu;
        }
        
        public boolean hasFri() {
            return this.Fri;
        }
        
        public boolean hasSat() {
            return this.Sat;
        }
        
        public boolean hasSun() {
            return this.Sun;
        }
    
}
