package org.leedberg.cotiro;
/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * Created on Aug 17, 2005
 * 
 * This class is used for the surprisingly complex task of setting
 * a constraint to be soft or hard upon construction.  You merely
 * need to construct a SoftSetting object with all of the relevant
 * information (soft constraints on/off for system? using default setting
 * for this constraint? user specification for this constraint?) and 
 * the useSoft method will return true or false for whether or not 
 * the constraint sohuld be soft.
 */
public class SoftSetting {
	private boolean doSoft;
	private boolean useDefault;
	private boolean userSetting;
	
	public SoftSetting(boolean doSoft, 	// on/off for system 
			boolean useDefault,  		// use constraint default 
			boolean userSetting) {		// user specification
		this.doSoft = doSoft;
		this.useDefault = useDefault;
		this.userSetting = userSetting;
	}
	
	public boolean useSoft(boolean defaultSetting) {
		if (!doSoft) {
			return false;
		}
		
		else if (useDefault) {
			return defaultSetting;
		}
		
		else {
			return userSetting;
		}
	}
}
