package org.leedberg.cotiro;

/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class State implements Cloneable
{	
	public VariableList assignedVars;
	public VariableList unassignedVars;

	/**
	 * 
	 */
	public State() {
		super();
		assignedVars = unassignedVars = null;
	}
	
	public State(VariableList assignedVars, VariableList unassignedVars) {
		this.assignedVars = assignedVars;
		this.unassignedVars = unassignedVars;
	}
	
	public VariableList getAssignedVars () { return assignedVars; };
	
	public VariableList getUnassignedVars () {return unassignedVars; };
	
	public String toString() {
		String retVal = "";
		
		retVal += "Assigned variables:\n";
		
		for (int i=0; i < assignedVars.size(); i++) {
			retVal = retVal + 
						"\n------------------------------------------------\n" +
						((Variable)assignedVars.get(i)).toString() + '\n';
		}	
		
		retVal += "\nUnassigned variables:\n";
		
		for (int i=0; i < unassignedVars.size(); i++) {
			retVal = retVal + ((Variable)unassignedVars.get(i)).toString() + '\n'; 
		}
		/*
		retVal += "\nAvailable values:\n";
		
		for (int i=0; i < availValues.size(); i++) {
			retVal = retVal + ((TimeRoom)availValues.get(i)).toString() + '\n';			
		}
				
*/
		retVal += '\n';
		
		return retVal;
	}
	
	public void println() {			
			CotiroLogic.println("Assigned variables:");
			
			for (int i=0; i < assignedVars.size(); i++) {
				CotiroLogic.println("------------------------------------------------");
				CotiroLogic.println(((Variable)assignedVars.get(i)).toString());
			}	
			
			CotiroLogic.println("\nUnassigned variables:");
			
			for (int i=0; i < unassignedVars.size(); i++) {
				CotiroLogic.println(((Variable)unassignedVars.get(i)).toString()); 
			}
			/*
			retVal += "\nAvailable values:\n";
			
			for (int i=0; i < availValues.size(); i++) {
				retVal = retVal + ((TimeRoom)availValues.get(i)).toString() + '\n';			
			}
					
	*/
			CotiroLogic.println("");
	}
	
	public Object clone() {
		try {
			State another = (State)super.clone();
			//another.availValues = (Vector)availValues.clone();
			another.assignedVars = (VariableList)assignedVars.clone();
			another.unassignedVars = (VariableList)unassignedVars.clone();
		
			return another;
		} catch (CloneNotSupportedException s) {
			return null;
		}		
	}
	
	public boolean allAssigned() {
		return (unassignedVars.size() == 0);
	}
}
