package org.leedberg.cotiro.college.constraints;

import org.leedberg.cotiro.Constraint;
import org.leedberg.cotiro.SoftSetting;
import org.leedberg.cotiro.VariableList;
import org.leedberg.cotiro.college.CourseSection;

/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class BuildingConstraint extends Constraint 
{

	/* (non-Javadoc)
	 * @see Constraint#satisfied(CourseSectionList)
	 */
	
	public BuildingConstraint(String course, String building, SoftSetting soft) {
	/*	A = course;
		B = building;*/
		super(course, building, soft.useSoft(true));
	}
	public boolean satisfied(VariableList vars) {


		CourseSection course = (CourseSection)vars.getVariable((String)A);
		// First, find if this course is in the vars list, if not, we are instantly
		// satisfied		
		
		
		if (course == null) {
			// Course is not in list, so no conflict can exist			
			return true;
		}
		else {
			return course.getTimeRoom().getBuilding().equals((String) B);
		}		
	}
	
	public String toString() {
		return "Building constraint: " + A + " must be in " + B;
	}
	
	public boolean isUnary() {
		return true;
	}
}
