package org.leedberg.cotiro.college.constraints;

import org.leedberg.cotiro.Constraint;
import org.leedberg.cotiro.SoftSetting;
import org.leedberg.cotiro.VariableList;
import org.leedberg.cotiro.college.CourseSection;

/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class SizeConstraint extends Constraint 
{

	/* (non-Javadoc)
	 * @see Constraint#satisfied(CourseSectionList)
	 */
	 
	public SizeConstraint(String courseName, SoftSetting soft) {
		// This is simply a constraint that the size of the room assigned
		// to the course is large enough for the class, only one
		// object needed
		super(courseName, null, soft.useSoft(true)); 
	}
	
	public boolean satisfied(VariableList vars) {


		CourseSection course = (CourseSection)vars.getVariable((String)A);
		
		if (course == null) {
			return true;
		}
		else {
			return course.getSize() <= course.getTimeRoom().getSize();
		}		
	}
	
	public String toString() {
		return "Size constraint: " + A + " must fit room";
	}
	
	public boolean isUnary() {
		return true;
	}
}
