/*
 * MainWindow.java
 *
 * Created on April 10, 2007, 5:54 PM
 */

// TODO: Tables should have row numbers! (non-editable column)... but this will change ALL table-editing code!!!!

// TODO: Maybe should use a special class for each table that represents its rows... rather than having
//       to use direct references to row numbers.  Constructor would take a row vector, and have methods
//       for accessing each column by name.  Only one place to change if table layouts change.
package org.leedberg.cotiro.gui;

import org.leedberg.cotiro.gui.shift.TravelTimeAdd;
import org.leedberg.cotiro.gui.college.TeacherAdd;
import org.leedberg.cotiro.gui.shift.ShiftAdd;
import org.leedberg.cotiro.gui.college.ScheduleAdd;
import org.leedberg.cotiro.gui.college.RoomAdd;
import org.leedberg.cotiro.gui.shift.ImportShift;
import org.leedberg.cotiro.gui.college.ImportCollege;
import org.leedberg.cotiro.gui.shift.EmployeeAdd;
import org.leedberg.cotiro.gui.college.CourseAdd;
import java.awt.Component;
import java.awt.Rectangle;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import org.apache.xmlbeans.XmlException;
import org.apache.xmlbeans.XmlOptions;
import org.leedberg.cotiro.*;
import org.leedberg.cotiro.CotiroDocument.Cotiro;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Buildings;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Buildings.Building;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Buildings.Building.Room;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Courses;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Courses.Course;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Employees;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee.Skill;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Schedules;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Schedules.Schedule;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Shifts;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Shifts.Shift;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Teachers;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Teachers.Teacher;
import org.leedberg.cotiro.CotiroDocument.Cotiro.TravelTimes;
import org.leedberg.cotiro.CotiroDocument.Cotiro.TravelTimes.TravelTime;
import org.leedberg.cotiro.gui.college.CourseRow;
import org.leedberg.cotiro.gui.college.RoomRow;
import org.leedberg.cotiro.gui.college.ScheduleRow;
import org.leedberg.cotiro.gui.college.TeacherRow;
import org.leedberg.cotiro.gui.shift.EmployeeRow;
import org.leedberg.cotiro.gui.shift.ShiftRow;
import org.leedberg.cotiro.gui.shift.TravelTimeRow;

/**
 *
 * @author  Greg
 */
public class MainWindow extends javax.swing.JFrame {

    private enum CotiroMode {

        NONE, COLLEGE, SHIFT
    }

    
    
        ;
    private   CotiroMode  cotiroMode = CotiroMode.NONE;
    

    private boolean saved = true;

    private class TableInformation {

        public JPanel panel;  // panel containing this table
        public JTable table;  // pointer to table

        public TableInformation(JPanel panel, JTable table) {
            this.panel = panel;
            this.table = table;
        }
    }
    private HashMap<String, TableInformation> tables;

    private class TableModifiedListener implements TableModelListener {

        public void tableChanged(TableModelEvent e) {

            MainWindow.this.saved = false;
        }
    }

    /** Creates new form MainWindow */
    public MainWindow() {
        initComponents();


        // Odd, but we have to remove each of the tabs now, so that we get a blank
        // screen on load.  When a new file is created, or one is opened, we will
        // selectively add the tab panels back in that are needed.
        this.tabPane.removeTabAt(0);
        this.tabPane.removeTabAt(0);
        this.tabPane.removeTabAt(0);
        this.tabPane.removeTabAt(0);
        this.tabPane.removeTabAt(0);
        this.tabPane.removeTabAt(0);
        this.tabPane.removeTabAt(0);

        // Load up some table information, indexed by common name of table
        // this will help us prevent hard-coding later
        tables = new HashMap<String, TableInformation>();
        tables.put("Schedules", new TableInformation(tabPanel1, scheduleTable));
        tables.put("Courses", new TableInformation(tabPanel2, coursesTable));
        tables.put("Teachers", new TableInformation(tabPanel3, teachersTable));
        tables.put("Rooms", new TableInformation(tabPanel4, buildingsTable));
        tables.put("Shifts", new TableInformation(tabPanel5, shiftTable));
        tables.put("Employees", new TableInformation(tabPanel6, employeeTable));
        tables.put("Travel Times", new TableInformation(tabPanel7, travelTimeTable));



    //this.tabPane.insertTab("Teachers", null, this.tabPanel3, null, 2);

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane3 = new javax.swing.JTabbedPane();
        tabPane = new javax.swing.JTabbedPane();
        tabPanel1 = new javax.swing.JPanel();
        scheduleTableScrollPane = new javax.swing.JScrollPane();
        scheduleTable = new javax.swing.JTable();
        addSchedule = new javax.swing.JButton();
        editSchedule = new javax.swing.JButton();
        tabPanel2 = new javax.swing.JPanel();
        coursesTableScrollPane = new javax.swing.JScrollPane();
        coursesTable = new javax.swing.JTable();
        addCourse = new javax.swing.JButton();
        editCourse = new javax.swing.JButton();
        tabPanel3 = new javax.swing.JPanel();
        teachersTableScrollPane = new javax.swing.JScrollPane();
        teachersTable = new javax.swing.JTable();
        addTeacher = new javax.swing.JButton();
        editTeacher = new javax.swing.JButton();
        tabPanel4 = new javax.swing.JPanel();
        buildingsTableScrollPane = new javax.swing.JScrollPane();
        buildingsTable = new javax.swing.JTable();
        addRoom = new javax.swing.JButton();
        addRoomToBuilding = new javax.swing.JButton();
        editRoom = new javax.swing.JButton();
        tabPanel5 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        shiftTable = new javax.swing.JTable();
        addShift = new javax.swing.JButton();
        editShift = new javax.swing.JButton();
        tabPanel6 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        employeeTable = new javax.swing.JTable();
        addEmployee = new javax.swing.JButton();
        editEmployee = new javax.swing.JButton();
        tabPanel7 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        travelTimeTable = new javax.swing.JTable();
        addTravelTime = new javax.swing.JButton();
        editTravelTime = new javax.swing.JButton();
        mainMenuBar = new javax.swing.JMenuBar();
        mainMenu = new javax.swing.JMenu();
        menuFileNew = new javax.swing.JMenu();
        menuFileNewCollege = new javax.swing.JMenuItem();
        menuFileNewShift = new javax.swing.JMenuItem();
        menuFileOpen = new javax.swing.JMenuItem();
        menuFileSave = new javax.swing.JMenuItem();
        menuFileSaveAs = new javax.swing.JMenuItem();
        menuFileExit = new javax.swing.JMenuItem();
        tableMenu = new javax.swing.JMenu();
        tableInsert = new javax.swing.JMenuItem();
        tableDelete = new javax.swing.JMenuItem();
        tableClear = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        tableImport = new javax.swing.JMenuItem();
        tableExport = new javax.swing.JMenuItem();
        toolsMenu = new javax.swing.JMenu();
        toolsValidate = new javax.swing.JMenuItem();
        toolsGenerate = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Cotiro");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        scheduleTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Days", "Day Start", "Day End", "Course Duration", "Course Break"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        scheduleTable.getModel().addTableModelListener(new TableModifiedListener());
        scheduleTable.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                scheduleTableKeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                scheduleTableKeyTyped(evt);
            }
        });
        scheduleTableScrollPane.setViewportView(scheduleTable);

        addSchedule.setText("Quick Add Schedule");
        addSchedule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addScheduleActionPerformed(evt);
            }
        });

        editSchedule.setText("Edit Selected Row");
        editSchedule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editScheduleActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel1Layout = new org.jdesktop.layout.GroupLayout(tabPanel1);
        tabPanel1.setLayout(tabPanel1Layout);
        tabPanel1Layout.setHorizontalGroup(
            tabPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(scheduleTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel1Layout.createSequentialGroup()
                        .add(addSchedule)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editSchedule)))
                .addContainerGap())
        );
        tabPanel1Layout.setVerticalGroup(
            tabPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(scheduleTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addSchedule)
                    .add(editSchedule))
                .addContainerGap())
        );

        tabPane.addTab("Schedule", tabPanel1);

        coursesTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Title", "Instructor", "Size"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        coursesTable.getModel().addTableModelListener(new TableModifiedListener());
        coursesTableScrollPane.setViewportView(coursesTable);

        addCourse.setText("Quick Add Course");
        addCourse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addCourseActionPerformed(evt);
            }
        });

        editCourse.setText("Edit Selected Row");
        editCourse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editCourseActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel2Layout = new org.jdesktop.layout.GroupLayout(tabPanel2);
        tabPanel2.setLayout(tabPanel2Layout);
        tabPanel2Layout.setHorizontalGroup(
            tabPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(coursesTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel2Layout.createSequentialGroup()
                        .add(addCourse)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editCourse)))
                .addContainerGap())
        );
        tabPanel2Layout.setVerticalGroup(
            tabPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(coursesTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addCourse)
                    .add(editCourse))
                .addContainerGap())
        );

        tabPane.addTab("Courses", tabPanel2);

        teachersTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Name", "Building", "Start Time", "End Time", "Properties"
            }
        ));
        teachersTable.getModel().addTableModelListener(new TableModifiedListener());
        teachersTableScrollPane.setViewportView(teachersTable);

        addTeacher.setText("Quick Add Teacher");
        addTeacher.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addTeacherActionPerformed(evt);
            }
        });

        editTeacher.setText("Edit Selected Row");
        editTeacher.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editTeacherActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel3Layout = new org.jdesktop.layout.GroupLayout(tabPanel3);
        tabPanel3.setLayout(tabPanel3Layout);
        tabPanel3Layout.setHorizontalGroup(
            tabPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(teachersTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel3Layout.createSequentialGroup()
                        .add(addTeacher)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editTeacher)))
                .addContainerGap())
        );
        tabPanel3Layout.setVerticalGroup(
            tabPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(teachersTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addTeacher)
                    .add(editTeacher))
                .addContainerGap())
        );

        tabPane.addTab("Teachers", tabPanel3);

        buildingsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Building Name", "Room Number", "Size"
            }
        ));
        buildingsTable.getModel().addTableModelListener(new TableModifiedListener());
        buildingsTableScrollPane.setViewportView(buildingsTable);

        addRoom.setText("Quick Add Room");
        addRoom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addRoomActionPerformed(evt);
            }
        });

        addRoomToBuilding.setText("Quick Add Room to Selected Building");
        addRoomToBuilding.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addRoomToBuildingActionPerformed(evt);
            }
        });

        editRoom.setText("Edit Selected Row");
        editRoom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editRoomActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel4Layout = new org.jdesktop.layout.GroupLayout(tabPanel4);
        tabPanel4.setLayout(tabPanel4Layout);
        tabPanel4Layout.setHorizontalGroup(
            tabPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(buildingsTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel4Layout.createSequentialGroup()
                        .add(addRoom)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(addRoomToBuilding)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editRoom)))
                .addContainerGap())
        );
        tabPanel4Layout.setVerticalGroup(
            tabPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(buildingsTableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addRoom)
                    .add(addRoomToBuilding)
                    .add(editRoom))
                .addContainerGap())
        );

        tabPane.addTab("Rooms", tabPanel4);

        shiftTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Location", "Skill Needed", "Start Time", "End Time", "Days"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        shiftTable.getModel().addTableModelListener(new TableModifiedListener());
        jScrollPane1.setViewportView(shiftTable);

        addShift.setText("Quick Add Shift");
        addShift.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addShiftActionPerformed(evt);
            }
        });

        editShift.setText("Edit Selected Row");
        editShift.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editShiftActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel5Layout = new org.jdesktop.layout.GroupLayout(tabPanel5);
        tabPanel5.setLayout(tabPanel5Layout);
        tabPanel5Layout.setHorizontalGroup(
            tabPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel5Layout.createSequentialGroup()
                        .add(addShift)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editShift)))
                .addContainerGap())
        );
        tabPanel5Layout.setVerticalGroup(
            tabPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addShift)
                    .add(editShift))
                .addContainerGap())
        );

        tabPane.addTab("Shifts", tabPanel5);

        employeeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null}
            },
            new String [] {
                "Name", "Skills", "Start Time", "End Time", "Days", "Properties"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        employeeTable.getModel().addTableModelListener(new TableModifiedListener());
        jScrollPane2.setViewportView(employeeTable);

        addEmployee.setText("Quick Add Employee");
        addEmployee.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addEmployeeActionPerformed(evt);
            }
        });

        editEmployee.setText("Edit Selected Row");
        editEmployee.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editEmployeeActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel6Layout = new org.jdesktop.layout.GroupLayout(tabPanel6);
        tabPanel6.setLayout(tabPanel6Layout);
        tabPanel6Layout.setHorizontalGroup(
            tabPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel6Layout.createSequentialGroup()
                        .add(addEmployee)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editEmployee)))
                .addContainerGap())
        );
        tabPanel6Layout.setVerticalGroup(
            tabPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addEmployee)
                    .add(editEmployee))
                .addContainerGap())
        );

        tabPane.addTab("Employees", tabPanel6);

        travelTimeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Location 1", "Location 2", "Travel Time (Minutes)"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        travelTimeTable.getModel().addTableModelListener(new TableModifiedListener());
        jScrollPane3.setViewportView(travelTimeTable);

        addTravelTime.setText("Quick Add Travel Time");
        addTravelTime.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addTravelTimeActionPerformed(evt);
            }
        });

        editTravelTime.setText("Edit Selected Row");
        editTravelTime.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editTravelTimeActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabPanel7Layout = new org.jdesktop.layout.GroupLayout(tabPanel7);
        tabPanel7.setLayout(tabPanel7Layout);
        tabPanel7Layout.setHorizontalGroup(
            tabPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 743, Short.MAX_VALUE)
                    .add(tabPanel7Layout.createSequentialGroup()
                        .add(addTravelTime)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(editTravelTime)))
                .addContainerGap())
        );
        tabPanel7Layout.setVerticalGroup(
            tabPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addTravelTime)
                    .add(editTravelTime))
                .addContainerGap())
        );

        tabPane.addTab("Travel Times", tabPanel7);

        mainMenu.setText("File");
        mainMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mainMenuActionPerformed(evt);
            }
        });

        menuFileNew.setText("New");

        menuFileNewCollege.setText("College Time and Room Schedule");
        menuFileNewCollege.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileNewCollegeActionPerformed(evt);
            }
        });
        menuFileNew.add(menuFileNewCollege);

        menuFileNewShift.setText("Shift-Based Employee Schedule");
        menuFileNewShift.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileNewShiftActionPerformed(evt);
            }
        });
        menuFileNew.add(menuFileNewShift);

        mainMenu.add(menuFileNew);

        menuFileOpen.setText("Open");
        menuFileOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileOpenActionPerformed(evt);
            }
        });
        mainMenu.add(menuFileOpen);

        menuFileSave.setText("Save");
        menuFileSave.setEnabled(false);
        menuFileSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileSaveActionPerformed(evt);
            }
        });
        mainMenu.add(menuFileSave);

        menuFileSaveAs.setText("Save As...");
        menuFileSaveAs.setEnabled(false);
        menuFileSaveAs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileSaveAsActionPerformed(evt);
            }
        });
        mainMenu.add(menuFileSaveAs);

        menuFileExit.setText("Exit");
        menuFileExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuFileExitActionPerformed(evt);
            }
        });
        mainMenu.add(menuFileExit);

        mainMenuBar.add(mainMenu);

        tableMenu.setText("Table");

        tableInsert.setText("Insert Row");
        tableInsert.setEnabled(false);
        tableInsert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tableInsertActionPerformed(evt);
            }
        });
        tableMenu.add(tableInsert);

        tableDelete.setText("Delete Row");
        tableDelete.setEnabled(false);
        tableDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tableDeleteActionPerformed(evt);
            }
        });
        tableMenu.add(tableDelete);

        tableClear.setText("Clear Table");
        tableClear.setEnabled(false);
        tableClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tableClearActionPerformed(evt);
            }
        });
        tableMenu.add(tableClear);
        tableMenu.add(jSeparator1);

        tableImport.setText("Import...");
        tableImport.setEnabled(false);
        tableImport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tableImportActionPerformed(evt);
            }
        });
        tableMenu.add(tableImport);

        tableExport.setText("Export...");
        tableExport.setEnabled(false);
        tableExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tableExportActionPerformed(evt);
            }
        });
        tableMenu.add(tableExport);

        mainMenuBar.add(tableMenu);

        toolsMenu.setText("Tools");

        toolsValidate.setText("Validate");
        toolsValidate.setEnabled(false);
        toolsValidate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toolsValidateActionPerformed(evt);
            }
        });
        toolsMenu.add(toolsValidate);

        toolsGenerate.setText("Generate Schedule");
        toolsGenerate.setEnabled(false);
        toolsGenerate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toolsGenerateActionPerformed(evt);
            }
        });
        toolsMenu.add(toolsGenerate);

        mainMenuBar.add(toolsMenu);

        setJMenuBar(mainMenuBar);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 768, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(tabPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 485, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void tableClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tableClearActionPerformed
        // TODO: We should probably warn the user that this will delete the entire table...
        if (this.cotiroMode == CotiroMode.COLLEGE) {
            switch (this.tabPane.getSelectedIndex()) {
                case 0:
                    this.clearTable(this.scheduleTable);
                    break;
                case 1:
                    this.clearTable(this.coursesTable);
                    break;
                case 2:
                    this.clearTable(this.teachersTable);
                    break;
                case 3:
                    this.clearTable(this.buildingsTable);
                    break;

            }
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            switch (this.tabPane.getSelectedIndex()) {
                case 0:
                    this.clearTable(this.shiftTable);
                    break;
                case 1:
                    this.clearTable(this.employeeTable);
                    break;
                case 2:
                    this.clearTable(this.travelTimeTable);
                    break;
            }
        }

        saved = false;
    }//GEN-LAST:event_tableClearActionPerformed

    private void tableImportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tableImportActionPerformed
        if (this.cotiroMode == CotiroMode.COLLEGE) {
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new ImportCollege(MainWindow.this.scheduleTable, MainWindow.this.coursesTable, MainWindow.this.teachersTable, MainWindow.this.buildingsTable).setVisible(true);
                }
            });
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new ImportShift(MainWindow.this.shiftTable, MainWindow.this.employeeTable, MainWindow.this.travelTimeTable).setVisible(true);
                }
            });

        }

        saved = false;
    }//GEN-LAST:event_tableImportActionPerformed

    private void tableExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tableExportActionPerformed
        if (this.cotiroMode == CotiroMode.COLLEGE) {
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new ExportTableFrame(MainWindow.this.scheduleTable, MainWindow.this.coursesTable, MainWindow.this.teachersTable, MainWindow.this.buildingsTable).setVisible(true);
                }
            });
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new ExportTableFrame(MainWindow.this.shiftTable, MainWindow.this.employeeTable, MainWindow.this.travelTimeTable, null).setVisible(true);
                }
            });

        }
        
    }//GEN-LAST:event_tableExportActionPerformed

    private void scheduleTableKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_scheduleTableKeyTyped
        this.saved = false;
    }//GEN-LAST:event_scheduleTableKeyTyped

    private void scheduleTableKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_scheduleTableKeyPressed
        this.saved = false;
    }//GEN-LAST:event_scheduleTableKeyPressed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        this.menuFileExitActionPerformed(null);
    }//GEN-LAST:event_formWindowClosing

    private void addTravelTimeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addTravelTimeActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new TravelTimeAdd(MainWindow.this).setVisible(true);
            }
        });
        
        
    }//GEN-LAST:event_addTravelTimeActionPerformed

    private void addEmployeeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addEmployeeActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new EmployeeAdd(MainWindow.this).setVisible(true);
            }
        });
        
        
    }//GEN-LAST:event_addEmployeeActionPerformed

    private void addShiftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addShiftActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new ShiftAdd(MainWindow.this).setVisible(true);
            }
        });
        
    }//GEN-LAST:event_addShiftActionPerformed

    private void toolsGenerateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toolsGenerateActionPerformed
        //CotiroLogic.outputDestination = CotiroLogic.OutputDestination.STRINGARRAY;

        //        CotiroConsole.main(new String[] {"--input",currentFile.getAbsolutePath(), "--output", "schedule", "--overwrite"});

        if (!saved) {
            JOptionPane pane = new JOptionPane("File has changed, you must save to disk for this action to work.");
            Object[] options = new String[]{"Save & Generate", "Cancel"};
            pane.setOptions(options);
            JDialog dialog = pane.createDialog(new JFrame(), "Save?");
            dialog.show();
            Object obj = pane.getValue();

            if (((String) obj).equals("Save & Generate")) {
                this.menuFileSaveAsActionPerformed(null);
            } else {
                return;
            }
        }
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new GenerateSchedule(MainWindow.this.currentFile).setVisible(true);
            }
        });
        
    }//GEN-LAST:event_toolsGenerateActionPerformed

    private void toolsValidateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toolsValidateActionPerformed
        ValidateResults vr = new ValidateResults();
        Vector tableData;
        int rowNum;

        if (this.cotiroMode == CotiroMode.COLLEGE) {
            // Validate the schedules table...
            tableData = ((DefaultTableModel) this.scheduleTable.getModel()).getDataVector();
            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String days = (String) r.get(0);
                String dayStart = (String) r.get(1);
                String dayEnd = (String) r.get(2);
                String courseDuration = (String) r.get(3);
                String courseBreak = (String) r.get(4);

                // If all of these are null, move on
                if (days == null &&
                        dayStart == null &&
                        dayEnd == null &&
                        courseDuration == null &&
                        courseBreak == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (days == null ||
                        dayStart == null ||
                        dayEnd == null ||
                        courseDuration == null ||
                        courseBreak == null) {
                    vr.addResult("Schedules", rowNum, r, "Some columns in row are empty.");
                }

                // Schedules: Days should be valid (MTWHF)
                if (!Days.isValid(days)) {
                    vr.addResult("Schedules", rowNum, r, "Days column contains invalid characters.");
                }

                // Schedules: Day Start / End should be valid times and format
                if (!Time.isValid(dayStart)) {
                    vr.addResult("Schedules", rowNum, r, "Day start is invalid.");
                }

                if (!Time.isValid(dayEnd)) {
                    vr.addResult("Schedules", rowNum, r, "Day end is invalid.");
                }
                // Schedules: Duration and Break should be valid (integers, less than the length of a day)
                try {
                    if (Integer.parseInt(courseDuration) > 1440) {
                        vr.addResult("Schedules", rowNum, r, "Course duration is longer than a day.");
                    }
                } catch (Exception e) {
                    vr.addResult("Schedules", rowNum, r, "Course duration is invalid.");
                }

                try {
                    if (Integer.parseInt(courseBreak) > 1440) {
                        vr.addResult("Schedules", rowNum, r, "Course break is longer than a day.");
                    }
                } catch (Exception e) {
                    vr.addResult("Schedules", rowNum, r, "Course break is invalid.");
                }

                // Schedules: Day Start < Day End
                if (Time.isValid(dayEnd) && Time.isValid(dayStart) && (new Time(dayEnd)).earlierThan((new Time(dayStart)))) {
                    vr.addResult("Schedules", rowNum, r, "Day end is earlier than day start.");
                }
            }

            // Validate the courses table...
            tableData = ((DefaultTableModel) this.coursesTable.getModel()).getDataVector();
            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String title = (String) r.get(0);
                String instructor = (String) r.get(1);
                String size = (String) r.get(2);


                // If all of these are null, move on
                if (title == null &&
                        instructor == null &&
                        size == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (title == null ||
                        instructor == null ||
                        size == null) {
                    vr.addResult("Courses", rowNum, r, "Some columns in row are empty.");
                }

                // Courses: Size should be an integer
                try {
                    Integer.parseInt(size);
                } catch (Exception e) {
                    vr.addResult("Courses", rowNum, r, "Course size is invalid.");
                }

            }

            // validate the teachers table
            tableData = ((DefaultTableModel) this.teachersTable.getModel()).getDataVector();
            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String name = (String) r.get(0);
                String building = (String) r.get(1);
                String startTime = (String) r.get(2);
                String endTime = (String) r.get(3);
                String props = (String) r.get(4);


                // If all of these are null, move on
                if (name == null &&
                        building == null &&
                        startTime == null &&
                        endTime == null &&
                        props == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (name == null ||
                        building == null ||
                        startTime == null ||
                        endTime == null ||
                        props == null) {
                    vr.addResult("Teachers", rowNum, r, "Some columns in row are empty.");
                }

                // Teachers: Does teacher appear somewhere in courses table?
                DefaultTableModel coursesModel = ((DefaultTableModel) this.coursesTable.getModel());
                boolean foundTeacher = false;
                for (int i = 0; i < coursesModel.getRowCount(); i++) {
                    if (coursesModel.getValueAt(i, 1) != null &&
                            coursesModel.getValueAt(i, 1).equals(name)) {
                        foundTeacher = true;
                        break;
                    }
                }
                if (!foundTeacher) {
                    vr.addResult("Teachers", rowNum, r, "Teacher does not exist in courses table.");
                }

                // Teachers: Does building appear somewhere in rooms table?
                DefaultTableModel buildingsModel = ((DefaultTableModel) this.buildingsTable.getModel());
                boolean foundBuilding = false;
                for (int i = 0; i < buildingsModel.getRowCount(); i++) {
                    if (buildingsModel.getValueAt(i, 0) != null &&
                            buildingsModel.getValueAt(i, 0).equals(building)) {
                        foundBuilding = true;
                        break;
                    }
                }
                if (!foundBuilding) {
                    vr.addResult("Teachers", rowNum, r, "Building does not exist in rooms table.");
                }

                // Teachers: Start / End time of correct format
                if (!Time.isValid(startTime)) {
                    vr.addResult("Teachers", rowNum, r, "Start time is invalid.");
                }

                if (!Time.isValid(endTime)) {
                    vr.addResult("Teachers", rowNum, r, "End time is invalid.");
                }
                // Teachers: Start time < End time
                if (Time.isValid(startTime) && Time.isValid(endTime) && (new Time(endTime)).earlierThan((new Time(startTime)))) {
                    vr.addResult("Teachers", rowNum, r, "End time is earlier than start time.");
                }

                // Teachers: Properties in correct format            
                if (props != null && !props.equals("") && !TableProperties.isValid(props)) {
                    vr.addResult("Teachers", rowNum, r, "Properties field has an incorrect format.");
                }
            }

            // Validate the rooms table...
            tableData = ((DefaultTableModel) this.buildingsTable.getModel()).getDataVector();

            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String name = (String) r.get(0);
                String number = (String) r.get(1);
                String size = (String) r.get(2);


                // If all of these are null, move on
                if (name == null &&
                        number == null &&
                        size == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (name == null ||
                        number == null ||
                        size == null) {
                    vr.addResult("Rooms", rowNum, r, "Some columns in row are empty.");
                }

                // Rooms: Size should be an integer
                try {
                    Integer.parseInt(size);
                } catch (Exception e) {
                    vr.addResult("Rooms", rowNum, r, "Room size is invalid.");
                }

            }
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            // Validate the shifts table...
            tableData = ((DefaultTableModel) this.shiftTable.getModel()).getDataVector();
            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String location = (String) r.get(0);
                String skill = (String) r.get(1);
                String startTime = (String) r.get(2);
                String endTime = (String) r.get(3);
                String days = (String) r.get(4);

                // If all of these are null, move on
                if (location == null &&
                        skill == null &&
                        startTime == null &&
                        endTime == null &&
                        days == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (location == null ||
                        skill == null ||
                        startTime == null ||
                        endTime == null ||
                        days == null) {
                    vr.addResult("Shifts", rowNum, r, "Some columns in row are empty.");
                }

                // Shifts: Skill should exist for some employee              
                DefaultTableModel employeeModel = ((DefaultTableModel) this.employeeTable.getModel());
                boolean foundSkill = false;
                for (int i = 0; i < employeeModel.getRowCount(); i++) {

                    if (employeeModel.getValueAt(i, 1) != null) {
                        Vector skills = new Vector(Arrays.asList(((String) employeeModel.getValueAt(i, 1)).split(";")));

                        if (skills.contains(skill)) {
                            foundSkill = true;
                            break;
                        }

                    }


                }
                if (!foundSkill) {
                    vr.addResult("Shifts", rowNum, r, "Skill does not exist in employees table.");
                }

                // Shifts: Start / End time in correct formats    
                if (!Time.isValid(startTime)) {
                    vr.addResult("Shifts", rowNum, r, "Start time is invalid.");
                }

                if (!Time.isValid(endTime)) {

                    vr.addResult("Shifts", rowNum, r, "End time is invalid.");
                }

                // Shifts: Start time < End time
                if (Time.isValid(startTime) && Time.isValid(endTime) && (new Time(endTime)).earlierThan((new Time(startTime)))) {
                    vr.addResult("Shifts", rowNum, r, "End time is earlier than start time.");
                }
                // Shifts: Days should be a valid string
                if (!Days.isValid(days)) {
                    vr.addResult("Shifts", rowNum, r, "Days column contains invalid characters.");
                }

            }

            // validate employees table...
            tableData = ((DefaultTableModel) this.employeeTable.getModel()).getDataVector();
            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String name = (String) r.get(0);
                String skills = (String) r.get(1);
                String startTime = (String) r.get(2);
                String endTime = (String) r.get(3);
                String days = (String) r.get(4);
                String props = (String) r.get(5);

                // If all of these are null, move on
                if (name == null &&
                        skills == null &&
                        startTime == null &&
                        endTime == null &&
                        days == null &&
                        props == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (name == null ||
                        skills == null ||
                        startTime == null ||
                        endTime == null ||
                        days == null ||
                        props == null) {
                    vr.addResult("Employees", rowNum, r, "Some columns in row are empty.");
                }

                // Employees: Start / End time correct format
                if (!Time.isValid(startTime)) {
                    vr.addResult("Employees", rowNum, r, "Start time is invalid.");
                }

                if (!Time.isValid(endTime)) {

                    vr.addResult("Employees", rowNum, r, "End time is invalid.");
                }

                // Employees: Start < End time
                if (Time.isValid(startTime) && Time.isValid(endTime) && (new Time(endTime)).earlierThan((new Time(startTime)))) {
                    vr.addResult("Employees", rowNum, r, "End time is earlier than start time.");
                }

                // Employees: Days string in correct format
                if (!Days.isValid(days)) {
                    vr.addResult("Employees", rowNum, r, "Days column contains invalid characters.");
                }

                // Employees: Properties in correct format
                if (props != null && !props.equals("") && !TableProperties.isValid(props)) {
                    vr.addResult("Employees", rowNum, r, "Properties field has an incorrect format.");
                }


            }

            // validate travel times table...
            tableData = ((DefaultTableModel) this.travelTimeTable.getModel()).getDataVector();
            rowNum = 0;
            for (Object row : tableData) {
                rowNum++;
                Vector r = (Vector) row;

                String location1 = (String) r.get(0);
                String location2 = (String) r.get(1);
                String travelTime = (String) r.get(2);

                // If all of these are null, move on
                if (location1 == null &&
                        location2 == null &&
                        travelTime == null) {
                    continue;
                }

                // First of all, if some of these are null but not all, this is a problem!
                if (location1 == null ||
                        location2 == null ||
                        travelTime == null) {
                    vr.addResult("Travel Times", rowNum, r, "Some columns in row are empty.");
                }

                // Travel times: Location 1/2 exist in Shifts table
                DefaultTableModel shiftsModel = ((DefaultTableModel) this.shiftTable.getModel());
                boolean foundLocation1 = false;
                boolean foundLocation2 = false;
                for (int i = 0; i < shiftsModel.getRowCount(); i++) {
                    if (shiftsModel.getValueAt(i, 0) != null &&
                            shiftsModel.getValueAt(i, 0).equals(location1)) {
                        foundLocation1 = true;
                    }
                    if (shiftsModel.getValueAt(i, 0) != null &&
                            shiftsModel.getValueAt(i, 0).equals(location2)) {
                        foundLocation2 = true;
                    }

                    if (foundLocation1 && foundLocation2) {
                        break;
                    }

                }
                if (!foundLocation1) {
                    vr.addResult("Travel Times", rowNum, r, "Location 1 does not exist in shifts table.");
                }

                if (!foundLocation2) {
                    vr.addResult("Travel Times", rowNum, r, "Location 2 does not exist in shifts table.");
                }

                // Travel times: Minutes is integer
                try {
                    Integer.parseInt(travelTime);
                } catch (Exception e) {
                    vr.addResult("Travel Times", rowNum, r, "Minutes field is invalid.");
                }

                // Travel times:  No duplication of location pairs
                for (int i = rowNum; i < tableData.size(); i++) {
                    Vector compareRow = (Vector) tableData.get(i);

                    String loc1 = (String) compareRow.get(0);
                    String loc2 = (String) compareRow.get(1);

                    if ((location1.equals(loc1) || location1.equals(loc2)) &&
                            (location2.equals(loc1) || location2.equals(loc2))) {
                        vr.addResult("Travel Times", rowNum, r, "Duplicate of row " + (i + 1));
                    }
                }
            }

        }
        System.out.println(vr);
        final ValidateResults vr2 = vr;
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new ValidateResultsFrame(vr2, MainWindow.this).setVisible(true);
            }
        });
    }//GEN-LAST:event_toolsValidateActionPerformed

    private void tableDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tableDeleteActionPerformed

        if (this.cotiroMode == CotiroMode.COLLEGE) {
            switch (this.tabPane.getSelectedIndex()) {
                case 0:
                    ((DefaultTableModel) this.scheduleTable.getModel()).removeRow(this.scheduleTable.getSelectedRow());
                    break;
                case 1:
                    ((DefaultTableModel) this.coursesTable.getModel()).removeRow(this.coursesTable.getSelectedRow());
                    break;
                case 2:
                    ((DefaultTableModel) this.teachersTable.getModel()).removeRow(this.teachersTable.getSelectedRow());
                    break;
                case 3:
                    ((DefaultTableModel) this.buildingsTable.getModel()).removeRow(this.buildingsTable.getSelectedRow());
                    break;


            }
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            switch (this.tabPane.getSelectedIndex()) {
                case 0:
                    ((DefaultTableModel) this.shiftTable.getModel()).removeRow(this.shiftTable.getSelectedRow());
                    break;
                case 1:
                    ((DefaultTableModel) this.employeeTable.getModel()).removeRow(this.employeeTable.getSelectedRow());
                    break;
                case 2:
                    ((DefaultTableModel) this.travelTimeTable.getModel()).removeRow(this.travelTimeTable.getSelectedRow());
                    break;
            }
        }

        saved = false;
    }//GEN-LAST:event_tableDeleteActionPerformed

    private void tableInsertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tableInsertActionPerformed
        if (this.cotiroMode == CotiroMode.COLLEGE) {
            switch (this.tabPane.getSelectedIndex()) {
                case 0:
                    ((DefaultTableModel) this.scheduleTable.getModel()).insertRow(this.scheduleTable.getSelectedRow() + 1, new String[]{"", "", "", "", ""});
                    break;
                case 1:
                    ((DefaultTableModel) this.coursesTable.getModel()).insertRow(this.coursesTable.getSelectedRow() + 1, new String[]{"", "", ""});
                    break;
                case 2:
                    ((DefaultTableModel) this.teachersTable.getModel()).insertRow(this.teachersTable.getSelectedRow() + 1, new String[]{"", "", "", ""});
                    break;
                case 3:
                    ((DefaultTableModel) this.buildingsTable.getModel()).insertRow(this.buildingsTable.getSelectedRow() + 1, new String[]{"", "", ""});
                    break;

            }
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            switch (this.tabPane.getSelectedIndex()) {
                case 0:
                    ((DefaultTableModel) this.shiftTable.getModel()).insertRow(this.shiftTable.getSelectedRow() + 1, new String[]{"", "", "", "", ""});
                    break;
                case 1:
                    ((DefaultTableModel) this.employeeTable.getModel()).insertRow(this.employeeTable.getSelectedRow() + 1, new String[]{"", "", "", "", ""});
                    break;
                case 2:
                    ((DefaultTableModel) this.travelTimeTable.getModel()).insertRow(this.travelTimeTable.getSelectedRow() + 1, new String[]{"", "", ""});
                    break;
            }
        }

        saved = false;
    }//GEN-LAST:event_tableInsertActionPerformed

    private void addRoomToBuildingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addRoomToBuildingActionPerformed

        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new RoomAdd(MainWindow.this, (String) MainWindow.this.buildingsTable.getModel().getValueAt(MainWindow.this.buildingsTable.getSelectedRow(), 0)).setVisible(true);
            }
        });
        
        
    }//GEN-LAST:event_addRoomToBuildingActionPerformed

    private void addRoomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addRoomActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new RoomAdd(MainWindow.this).setVisible(true);
            }
        });
        
        
    }//GEN-LAST:event_addRoomActionPerformed

    private void addTeacherActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addTeacherActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new TeacherAdd(MainWindow.this).setVisible(true);
            }
        });
        
    }//GEN-LAST:event_addTeacherActionPerformed

    private void addCourseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addCourseActionPerformed

        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new CourseAdd(MainWindow.this).setVisible(true);
            }
        });
        
    }//GEN-LAST:event_addCourseActionPerformed

    private void addScheduleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addScheduleActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new ScheduleAdd(MainWindow.this).setVisible(true);
            }
        });
        
    }//GEN-LAST:event_addScheduleActionPerformed

    private void setUpTabs() {
        this.tabPane.removeAll();
        if (this.cotiroMode == CotiroMode.COLLEGE) {
            this.tabPane.addTab("Schedules", this.tabPanel1);
            this.tabPane.addTab("Courses", this.tabPanel2);
            this.tabPane.addTab("Teachers", this.tabPanel3);
            this.tabPane.addTab("Rooms", this.tabPanel4);

            this.clearTable(this.scheduleTable);
            this.clearTable(this.coursesTable);
            this.clearTable(this.teachersTable);
            this.clearTable(this.buildingsTable);

        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            this.tabPane.addTab("Shifts", this.tabPanel5);
            this.tabPane.addTab("Employees", this.tabPanel6);
            this.tabPane.addTab("Travel Times", this.tabPanel7);

            this.clearTable(this.shiftTable);
            this.clearTable(this.employeeTable);
            this.clearTable(this.travelTimeTable);
        }

    }

    private void clearTable(JTable table) {
        while (((DefaultTableModel) table.getModel()).getRowCount() > 0) {
            ((DefaultTableModel) table.getModel()).removeRow(0);
        }

        //((DefaultTableModel)table.getModel()).setRowCount(1000);
        this.addBlankRowsToTable(table);
    }

    private void menuFileNewShiftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileNewShiftActionPerformed
        this.cotiroMode = CotiroMode.SHIFT;
        this.setUpTabs();
        this.activateMenuOptions();
        saved = true;
        currentFile = null;
        this.setTitle("Cotiro");        
    }//GEN-LAST:event_menuFileNewShiftActionPerformed

    private void mainMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mainMenuActionPerformed
        
    }//GEN-LAST:event_mainMenuActionPerformed

    private void menuFileNewCollegeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileNewCollegeActionPerformed
        this.cotiroMode = CotiroMode.COLLEGE;
        this.setUpTabs();
        this.activateMenuOptions();
        saved = true;

        currentFile = null;
        this.setTitle("Cotiro");
    }//GEN-LAST:event_menuFileNewCollegeActionPerformed

    private void menuFileExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileExitActionPerformed
        if (!saved) {
            JOptionPane pane = new JOptionPane("File has changed, save before exiting?");
            Object[] options = new String[]{"Save", "Don't save"};
            pane.setOptions(options);
            JDialog dialog = pane.createDialog(new JFrame(), "Save?");
            dialog.show();
            Object obj = pane.getValue();

            if (((String) obj).equals("Save")) {
                if (currentFile == null) {
                    this.menuFileSaveAsActionPerformed(null);
                } else {
                    this.saveFile(currentFile);
                }
            }
        }
        System.exit(0);
    }//GEN-LAST:event_menuFileExitActionPerformed

    // Add 1000 blank rows to a table
    public static void addBlankRowsToTable(JTable table) {
        ((DefaultTableModel) table.getModel()).setNumRows(((DefaultTableModel) table.getModel()).getRowCount() + 1000);
    }

    // Remove all empty rows from a table
    public static void cleanTableModel(JTable table) {
        DefaultTableModel model = (DefaultTableModel) table.getModel();
        Vector tableData = model.getDataVector();
        //int rows = model.getRowCount()

        // Iterate over every row
        for (int i = 0; i < model.getRowCount(); i++) {
            //Get the vector representing the row
            Vector row = (Vector) tableData.get(i);

            boolean emptyRow = true;
            // Iterate over every value in the row
            for (Object o : row) {
                String s = (String) o;

                if (s != null) {
                    // If we find just one value, it's not empty
                    emptyRow = false;
                }
            }

            if (emptyRow) {
                // It's empty, so we can remove it
                model.removeRow(i);

                // This will shift all rows down, so we want to not increment i
                i--;
            }
        }
    }

    private void menuFileOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileOpenActionPerformed
        if (!saved) {
            JOptionPane pane = new JOptionPane("File has changed, save before closing?");
            Object[] options = new String[]{"Save", "Don't save"};
            pane.setOptions(options);
            JDialog dialog = pane.createDialog(new JFrame(), "Save?");
            dialog.show();
            Object obj = pane.getValue();

            if (((String) obj).equals("Save")) {
                if (currentFile == null) {
                    this.menuFileSaveAsActionPerformed(null);
                } else {
                    this.saveFile(currentFile);
                }
            }
        }

        int returnVal = fc.showOpenDialog(this);


        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();


            CotiroDocument doc = null;

            try {
                doc = CotiroDocument.Factory.parse(file);
            } catch (IOException ex) {
                ex.printStackTrace();
            } catch (XmlException ex) {
                ex.printStackTrace();
            }

            // Have now loaded and parsed the XML file.
            // Need to populate the visual tables now...

            // TODO: All of this fails if people save files without tables.... 
            // which may happen while a file is in development.  It would be better
            // to have a required node which identifies the file type

            // First, need to figure out what type of file this is!!
            // so that we can get the right tabs added and set the right
            // mode
            if (doc.getCotiro().getBuildings() != null && doc.getCotiro().getCourses() != null) {
                this.cotiroMode = CotiroMode.COLLEGE;
                this.setUpTabs();

                DefaultTableModel tableModel = (DefaultTableModel) this.scheduleTable.getModel();

                System.out.println("Row count = " + tableModel.getRowCount());
                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                Schedule[] schedules = doc.getCotiro().getSchedules().getScheduleArray();

                for (Schedule s : schedules) { // loop over each schedule defined
                    Vector v = new Vector(); // row for this schedule
                    v.add(s.getDays().toString());
                    v.add(s.getDayStart().toString());
                    v.add(s.getDayEnd().toString());
                    v.add(s.getCourseDuration().toString());
                    v.add(s.getCourseBreak().toString());

                    tableModel.addRow(v);
                }

                this.addBlankRowsToTable(scheduleTable);

                tableModel = (DefaultTableModel) this.coursesTable.getModel();

                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                Course[] courses = doc.getCotiro().getCourses().getCourseArray();

                for (Course c : courses) { // loop over each schedule defined
                    Vector v = new Vector(); // row for this schedule

                    v.add(c.getTitle().toString());
                    v.add(c.getInstructor().toString());
                    v.add(c.getSize().toString());

                    tableModel.addRow(v);
                }

                this.addBlankRowsToTable(coursesTable);

                tableModel = (DefaultTableModel) this.teachersTable.getModel();

                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                if (doc.getCotiro().getTeachers() != null) {
                    Teacher[] teachers = doc.getCotiro().getTeachers().getTeacherArray();


                    for (Teacher t : teachers) { // loop over each schedule defined
                        Vector v = new Vector(); // row for this schedule

                        v.add(t.getName().toString());
                        v.add(t.getBuilding().toString());
                        v.add(t.getStartTime().toString());
                        v.add(t.getEndTime().toString());

                        TableProperties tableProps = new TableProperties();
                        if (t.getProperties() != null) {
                            org.leedberg.cotiro.CotiroDocument.Cotiro.Teachers.Teacher.Properties props = t.getProperties();
                            for (org.leedberg.cotiro.CotiroDocument.Cotiro.Teachers.Teacher.Properties.Property prop : props.getPropertyArray()) {
                                //propString += prop.getName() + "=" + prop.getValue();
                                tableProps.setProperty(prop.getName(), prop.getValue());
                            }
                        }
                        v.add(tableProps.toString());



                        tableModel.addRow(v);
                    }
                }

                this.addBlankRowsToTable(teachersTable);

                tableModel = (DefaultTableModel) this.buildingsTable.getModel();

                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                Building[] buildings = doc.getCotiro().getBuildings().getBuildingArray();

                for (Building b : buildings) { // loop over each schedule defined

                    String buildingName = b.getName();

                    for (Room r : b.getRoomArray()) {
                        Vector v = new Vector(); // row for this schedule
                        v.add(buildingName);
                        v.add(r.getNum().toString());
                        v.add(r.getSize().toString());

                        tableModel.addRow(v);

                    }

                }

                this.addBlankRowsToTable(buildingsTable);

            } else if (doc.getCotiro().getEmployees() != null && doc.getCotiro().getShifts() != null) {
                this.cotiroMode = CotiroMode.SHIFT;
                this.setUpTabs();

                // Need to load the shift file here

                DefaultTableModel tableModel = (DefaultTableModel) this.shiftTable.getModel();

                System.out.println("Row count = " + tableModel.getRowCount());
                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                Shift[] shifts = doc.getCotiro().getShifts().getShiftArray();

                for (Shift s : shifts) { // loop over each schedule defined
                    Vector v = new Vector(); // row for this schedule
                    v.add(s.getLocation().toString());
                    v.add(s.getSkill().toString());
                    v.add(s.getStartTime().toString());
                    v.add(s.getEndTime().toString());
                    v.add(s.getDays().toString());

                    tableModel.addRow(v);
                }

                this.addBlankRowsToTable(shiftTable);

                tableModel = (DefaultTableModel) this.employeeTable.getModel();

                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                Employee[] employees = doc.getCotiro().getEmployees().getEmployeeArray();

                for (Employee e : employees) { // loop over each schedule defined
                    Vector v = new Vector(); // row for this schedule
                    v.add(e.getName().toString());
                    String skills = "";

                    for (Skill s : e.getSkillArray()) {
                        if (s.getLimit() == null) {
                            skills += s.getName() + ";";
                        } else {
                            skills += s.getName() + "(" + s.getLimit().intValue() + ")" + ";";
                        }
                    }
                    skills = skills.substring(0, skills.length() - 1);
                    v.add(skills);
                    v.add(e.getStartTime().toString());
                    v.add(e.getEndTime().toString());
                    v.add(e.getDays().toString());

                    TableProperties tableProps = new TableProperties();
                    if (e.getProperties() != null) {
                        org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee.Properties props = e.getProperties();
                        for (org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee.Properties.Property prop : props.getPropertyArray()) {
                            tableProps.setProperty(prop.getName(), prop.getValue());
                        }
                    }
                    v.add(tableProps.toString());


                    tableModel.addRow(v);
                }

                this.addBlankRowsToTable(employeeTable);

                tableModel = (DefaultTableModel) this.travelTimeTable.getModel();

                // Remove each existing row
                while (tableModel.getRowCount() > 0) {
                    tableModel.removeRow(0);
                }

                if (doc.getCotiro().getTravelTimes() != null) {
                    TravelTime[] travelTimes = doc.getCotiro().getTravelTimes().getTravelTimeArray();


                    for (TravelTime t : travelTimes) { // loop over each schedule defined
                        Vector v = new Vector(); // row for this schedule
                        v.add(t.getLocationArray(0).toString());
                        v.add(t.getLocationArray(1).toString());
                        v.add(t.getTime().toString());
                        tableModel.addRow(v);
                    }
                }
                this.addBlankRowsToTable(travelTimeTable);


            } else {
                throw new IllegalStateException("Bad file");
            }



            currentFile = file;
            this.setTitle("Cotiro [" + currentFile.getName() + "]");
            this.activateMenuOptions();
            saved = true;
        }
        
    }//GEN-LAST:event_menuFileOpenActionPerformed

    private void menuFileSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileSaveActionPerformed
        if (currentFile != null) {
            this.saveFile(currentFile);
        } else {
            this.menuFileSaveAsActionPerformed(null);
        }
        
        
    }//GEN-LAST:event_menuFileSaveActionPerformed

    private void menuFileSaveAsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuFileSaveAsActionPerformed

        int returnVal = fc.showSaveDialog(this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            if (file.exists()) {
                // prompt for overwrite
                int n = JOptionPane.showConfirmDialog(
                        this,
                        "File already exists, overwrite?",
                        "File exists",
                        JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);

                // Abort if they say no
                if (n == JOptionPane.NO_OPTION) return;
            }
                this.saveFile(file);

                this.currentFile = file;
                this.setTitle("Cotiro [" + currentFile.getName() + "]");

        }
    }//GEN-LAST:event_menuFileSaveAsActionPerformed

    private void editScheduleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editScheduleActionPerformed
        final int row = this.scheduleTable.getSelectedRow();

        if (row >= 0) {
            final ScheduleRow rowContents = new ScheduleRow((Vector) ((DefaultTableModel) this.scheduleTable.getModel()).getDataVector().get(row));

            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new ScheduleAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_editScheduleActionPerformed

    private void editCourseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editCourseActionPerformed
        final int row = this.coursesTable.getSelectedRow();

        if (row >= 0) {
            final CourseRow rowContents = new CourseRow((Vector) ((DefaultTableModel) this.coursesTable.getModel()).getDataVector().get(row));
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new CourseAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }

    }//GEN-LAST:event_editCourseActionPerformed

    private void editTeacherActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editTeacherActionPerformed
        final int row = this.teachersTable.getSelectedRow();

        if (row >= 0) {
            final TeacherRow rowContents = new TeacherRow((Vector) ((DefaultTableModel) this.teachersTable.getModel()).getDataVector().get(row));
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new TeacherAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_editTeacherActionPerformed

    private void editRoomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editRoomActionPerformed
        final int row = this.buildingsTable.getSelectedRow();

        if (row >= 0) {
            final RoomRow rowContents = new RoomRow((Vector) ((DefaultTableModel) this.buildingsTable.getModel()).getDataVector().get(row));
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new RoomAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_editRoomActionPerformed

    private void editShiftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editShiftActionPerformed
        final int row = this.shiftTable.getSelectedRow();

        if (row >= 0) {
            final ShiftRow rowContents = new ShiftRow((Vector) ((DefaultTableModel) this.shiftTable.getModel()).getDataVector().get(row));
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new ShiftAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_editShiftActionPerformed

    private void editEmployeeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editEmployeeActionPerformed
        final int row = this.employeeTable.getSelectedRow();

        if (row >= 0) {
            final EmployeeRow rowContents = new EmployeeRow((Vector) ((DefaultTableModel) this.employeeTable.getModel()).getDataVector().get(row));
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new EmployeeAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_editEmployeeActionPerformed

    private void editTravelTimeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editTravelTimeActionPerformed
        final int row = this.travelTimeTable.getSelectedRow();

        if (row >= 0) {
            final TravelTimeRow rowContents = new TravelTimeRow((Vector) ((DefaultTableModel) this.travelTimeTable.getModel()).getDataVector().get(row));
            java.awt.EventQueue.invokeLater(new Runnable() {

                public void run() {
                    new TravelTimeAdd(MainWindow.this, rowContents, row).setVisible(true);
                }
            });
        }
    }//GEN-LAST:event_editTravelTimeActionPerformed

    private void saveFile(File file) {

        // Should add some error checking, what if not all fields in a row are filled in?
        CotiroDocument doc = CotiroDocument.Factory.newInstance();
        Cotiro cotiro = doc.addNewCotiro();

        if (this.cotiroMode == CotiroMode.COLLEGE) {
            Schedules schedules = cotiro.addNewSchedules();

            Courses courses = cotiro.addNewCourses();

            Teachers teachers = cotiro.addNewTeachers();

            Buildings buildings = cotiro.addNewBuildings();

            // Save the Schedules tab...
            DefaultTableModel tableModel = (DefaultTableModel) this.scheduleTable.getModel();
            Vector data = tableModel.getDataVector();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null &&
                        row.get(3) == null &&
                        row.get(4) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null ||
                        row.get(3) == null ||
                        row.get(4) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.
                    (new ErrorWindow()).setVisible(true);
                    return;
                }


                // columns = days daystart dayend courseduration coursebreak
                Schedule schedule = schedules.addNewSchedule();
                schedule.setDays((String) row.get(0));
                schedule.setDayStart((String) row.get(1));
                schedule.setDayEnd((String) row.get(2));

                schedule.setCourseDuration(BigInteger.valueOf(Integer.parseInt((String) row.get(3))));
                schedule.setCourseBreak(BigInteger.valueOf(Integer.parseInt((String) row.get(4))));

            }

            // Save the Courses tab...
            tableModel = (DefaultTableModel) this.coursesTable.getModel();
            data = tableModel.getDataVector();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.
                    (new ErrorWindow()).setVisible(true);
                    return;
                }


                // columns = title instructor size
                Course course = courses.addNewCourse();
                course.setTitle((String) row.get(0));
                course.setInstructor((String) row.get(1));
                System.err.println("Row # = " + i);
                System.err.println("Col 2 = " + (String) row.get(2));

                course.setSize(BigInteger.valueOf(Integer.parseInt((String) row.get(2))));
            }

            // Save the Teachers tab...
            tableModel = (DefaultTableModel) this.teachersTable.getModel();
            data = tableModel.getDataVector();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null &&
                        row.get(3) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null ||
                        row.get(3) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.
                    (new ErrorWindow()).setVisible(true);
                    return;
                }


                // columns = name building starttime endtime
                Teacher teacher = teachers.addNewTeacher();
                teacher.setName((String) row.get(0));
                teacher.setBuilding((String) row.get(1));
                teacher.setStartTime((String) row.get(2));
                teacher.setEndTime((String) row.get(3));

                org.leedberg.cotiro.CotiroDocument.Cotiro.Teachers.Teacher.Properties properties = teacher.addNewProperties();
                if (row.get(4) != null && ((String) row.get(4)).indexOf('=') >= 0) {
                    // onlt want to do this if there are properties...
                    TableProperties props = new TableProperties();
                    props.loadFromString((String) row.get(4));

                    // Iterate over properties, adding each one to xmlbean
                    Set keys = props.keySet();
                    Iterator j = keys.iterator();
                    while (j.hasNext()) {
                        String key = (String) j.next();
                        String value = (String) props.getProperty(key);
                        org.leedberg.cotiro.CotiroDocument.Cotiro.Teachers.Teacher.Properties.Property prop = properties.addNewProperty();
                        prop.setName(key);
                        prop.setValue(value);

                    }
                }

            }


            // Save the Rooms tab...
            tableModel = (DefaultTableModel) this.buildingsTable.getModel();
            data = tableModel.getDataVector();
            HashMap buildingHash = new HashMap();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.
                    (new ErrorWindow()).setVisible(true);
                    return;
                }


                // columns = building roomNum size

                // First, we have to find out if this building has already been added
                Building building = (Building) buildingHash.get(row.get(0));

                if (building == null) {
                    // First encounter of this building
                    building = buildings.addNewBuilding();
                    building.setName((String) row.get(0));

                    buildingHash.put(row.get(0), building);
                }

                Room room = building.addNewRoom();
                room.setNum((String) row.get(1));
                room.setSize(BigInteger.valueOf(Integer.parseInt((String) row.get(2))));
            }
        } else if (this.cotiroMode == CotiroMode.SHIFT) {
            Shifts shifts = cotiro.addNewShifts();
            Employees employees = cotiro.addNewEmployees();

            // we only want to add this section if there are travel times
            TravelTimes travelTimes = null;

            // Save the Shifts tab...
            DefaultTableModel tableModel = (DefaultTableModel) this.shiftTable.getModel();
            Vector data = tableModel.getDataVector();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null &&
                        row.get(3) == null &&
                        row.get(4) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null ||
                        row.get(3) == null ||
                        row.get(4) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.
                    (new ErrorWindow()).setVisible(true);
                    return;
                }


                // columns = days daystart dayend courseduration coursebreak
                Shift shift = shifts.addNewShift();
                shift.setLocation((String) row.get(0));
                shift.setSkill((String) row.get(1));
                shift.setStartTime((String) row.get(2));
                shift.setEndTime((String) row.get(3));
                shift.setDays((String) row.get(4));
            }

            // Save the Employees tab...
            tableModel = (DefaultTableModel) this.employeeTable.getModel();
            data = tableModel.getDataVector();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null &&
                        row.get(3) == null &&
                        row.get(4) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null ||
                        row.get(3) == null ||
                        row.get(4) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.
                    (new ErrorWindow()).setVisible(true);
                    return;
                }


                Employee employee = employees.addNewEmployee();
                employee.setName((String) row.get(0));

                String[] parsedSkills = ((String) row.get(1)).split(";");
                Skill[] skills = new Skill[parsedSkills.length];
                for (int j = 0; j < parsedSkills.length; j++) {
                    skills[j] = Skill.Factory.newInstance();

                    if ((parsedSkills[j].indexOf('(') >= 0) && (parsedSkills[j].indexOf(')') >= 0)) {
                        // contains a limit
                        skills[j].setName(parsedSkills[j].substring(0, parsedSkills[j].indexOf('(')));
                        skills[j].setLimit(BigInteger.valueOf(Long.valueOf(parsedSkills[j].substring(parsedSkills[j].indexOf('(') + 1, parsedSkills[j].indexOf(')')))));
                    } else {
                        skills[j].setName(parsedSkills[j]);
                        skills[j].setLimit(null);
                    }
                }

                employee.setSkillArray(skills);
                employee.setStartTime((String) row.get(2));
                employee.setEndTime((String) row.get(3));
                employee.setDays((String) row.get(4));

                org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee.Properties properties = employee.addNewProperties();
                if (row.get(5) != null && ((String) row.get(5)).indexOf('=') >= 0) {
                    // onlt want to do this if there are properties...
                    TableProperties props = new TableProperties();
                    props.loadFromString((String) row.get(5));

                    // Iterate over properties, adding each one to xmlbean
                    Set keys = props.keySet();
                    Iterator j = keys.iterator();
                    while (j.hasNext()) {
                        String key = (String) j.next();
                        String value = (String) props.getProperty(key);
                        org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee.Properties.Property prop = properties.addNewProperty();
                        prop.setName(key);
                        prop.setValue(value);

                    }
                }
            }

            // Save the Travel Time tab...
            tableModel = (DefaultTableModel) this.travelTimeTable.getModel();
            data = tableModel.getDataVector();

            for (int i = 0; i < data.size(); i++) {
                Vector row = (Vector) data.get(i);

                if (row.get(0) == null &&
                        row.get(1) == null &&
                        row.get(2) == null) {
                    // If ALL columns in this row are null, this isn't really
                    // and error, the user just didn't fill in this row.  Skip it.
                    continue;
                } else if (row.get(0) == null ||
                        row.get(1) == null ||
                        row.get(2) == null) {
                    // Not all of the columns are null, but some are... uh-oh, this
                    // is an error.

                    System.err.println("Travel Time error!");
                    (new ErrorWindow()).setVisible(true);
                    return;
                }

                if (travelTimes == null) {
                    travelTimes = cotiro.addNewTravelTimes();
                }

                TravelTime travelTime = travelTimes.addNewTravelTime();
                travelTime.setLocationArray(new String[]{(String) row.get(0), (String) row.get(1)});
                travelTime.setTime(BigInteger.valueOf(Integer.parseInt((String) row.get(2))));
            }
        }


        try {

            doc.save(file, new XmlOptions().setUseDefaultNamespace());
        } catch (IOException ex) {
            ex.printStackTrace();
        }

        saved = true;
    }

    public void addSchedule(String days, String startTime, String endTime, String courseDuration, String courseBreak, int row) {

        if (row == -1) {
            // Add new row to top
            ((DefaultTableModel) this.scheduleTable.getModel()).insertRow(0, new String[]{days, startTime, endTime, courseDuration, courseBreak});
        } else {
            // Remove specified row, then replace it with this data.
            ((DefaultTableModel) this.scheduleTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.scheduleTable.getModel()).insertRow(row, new String[]{days, startTime, endTime, courseDuration, courseBreak});
        }
        saved = false;
    }

    public void addCourse(String title, String instructor, String size, int row) {

        if (row == -1) {
            ((DefaultTableModel) this.coursesTable.getModel()).insertRow(0, new String[]{title, instructor, size});
        } else {
            ((DefaultTableModel) this.coursesTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.coursesTable.getModel()).insertRow(row, new String[]{title, instructor, size});

        }
        saved = false;
    }

    public void addTeacher(String name, String building, String startTime, String endTime, String properties, int row) {
        if (row == -1) {
            ((DefaultTableModel) this.teachersTable.getModel()).insertRow(0, new String[]{name, building, startTime, endTime, properties});
        } else {
            ((DefaultTableModel) this.teachersTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.teachersTable.getModel()).insertRow(row, new String[]{name, building, startTime, endTime, properties});
        }
        saved = false;
    }

    public void addRoom(String building, String room, String capacity, int row) {
        if (row == -1) {
            ((DefaultTableModel) this.buildingsTable.getModel()).insertRow(0, new String[]{building, room, capacity});
        } else {
            ((DefaultTableModel) this.buildingsTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.buildingsTable.getModel()).insertRow(row, new String[]{building, room, capacity});
        }
        saved = false;
    }

    public void addShift(String location, String skillNeeded, String startTime, String endTime, String days, int row) {
        if (row == -1) {
            ((DefaultTableModel) this.shiftTable.getModel()).insertRow(0, new String[]{location, skillNeeded, startTime, endTime, days});
        } else {
            ((DefaultTableModel) this.shiftTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.shiftTable.getModel()).insertRow(row, new String[]{location, skillNeeded, startTime, endTime, days});
        }
        saved = false;
    }

    public void addEmployee(String name, String skills, String startTime, String endTime, String days, String properties, int row) {
        if (row == -1) {
            ((DefaultTableModel) this.employeeTable.getModel()).insertRow(0, new String[]{name, skills, startTime, endTime, days, properties});
        } else {
            ((DefaultTableModel) this.employeeTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.employeeTable.getModel()).insertRow(row, new String[]{name, skills, startTime, endTime, days, properties});
        }
        saved = false;
    }

    public void addTravelTime(String location1, String location2, String travelTime, int row) {
        if (row == -1) {
            ((DefaultTableModel) this.travelTimeTable.getModel()).insertRow(0, new String[]{location1, location2, travelTime});
        } else {
            ((DefaultTableModel) this.travelTimeTable.getModel()).removeRow(row);
            ((DefaultTableModel) this.travelTimeTable.getModel()).insertRow(row, new String[]{location1, location2, travelTime});
        }
        saved = false;
    }

    // enables all of the menu items that should be active when a file is open
    public void activateMenuOptions() {
        this.menuFileSave.setEnabled(true);
        this.menuFileSaveAs.setEnabled(true);
        this.tableDelete.setEnabled(true);
        this.tableClear.setEnabled(true);
        this.tableExport.setEnabled(true);
        this.tableImport.setEnabled(true);
        this.tableInsert.setEnabled(true);
        this.toolsGenerate.setEnabled(true);
        this.toolsValidate.setEnabled(true);
    }

    public static void loadTableFromFile(String filename, JTable table) {
        try {
            BufferedReader reader = new BufferedReader(new FileReader(filename));

            String line;

            // We will clean the table model (remove blank
            // rows), and then we can just add new rows to the end, and then
            // add blank rows to it
            MainWindow.cleanTableModel(table);

            while ((line = reader.readLine()) != null) {
                // parse the line on commas
                // TODO: Maybe set a limit since we know how many columns there are??
                String[] values = line.split(",");

                // create a vector for this row
                Vector row = new Vector();
                for (String s : values) {

                    row.add(s);
                }

                ((DefaultTableModel) table.getModel()).addRow(row);
            }

            MainWindow.addBlankRowsToTable(table);

        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public static void browseForCSV(JTextField text, Component comp) {
        JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new java.io.File("."));

        chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        //
        // disable the "All files" option.
        //
        chooser.setAcceptAllFileFilterUsed(false);
        //

        chooser.setFileFilter(new CSVFileFilter());
        if (chooser.showOpenDialog(comp) == JFileChooser.APPROVE_OPTION) {
            text.setText(chooser.getSelectedFile().toString());
        }
    }

    public void scrollTableToRow(String tableName, int row) {
        /*
        if (tableName.equals("Schedules")) {
        scrollTableToRow(tabPanel1, scheduleTable, row);
        }*/

        TableInformation info = tables.get(tableName);

        if (info == null) {
            throw new IllegalArgumentException();
        }

        scrollTableToRow(info.panel, info.table, row);
    }

    // Opens tab containing panel, and scrolls table to specified row
    private void scrollTableToRow(JPanel panel, JTable table, int row) {
        tabPane.setSelectedComponent(panel);
        table.setRowSelectionInterval(row, row);
        Rectangle rect = table.getCellRect(row, 0, true);
        table.scrollRectToVisible(rect);
    }

    public static void checkBoxesForDays(String daysString, JCheckBox mon, JCheckBox tue, JCheckBox wed, JCheckBox thu, JCheckBox fri, JCheckBox sat, JCheckBox sun) {
        Days days = new Days(daysString);

        mon.setSelected(days.hasMon());
        tue.setSelected(days.hasTue());
        wed.setSelected(days.hasWed());
        thu.setSelected(days.hasThu());
        fri.setSelected(days.hasFri());
        sat.setSelected(days.hasSat());
        sun.setSelected(days.hasSun());
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new MainWindow().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addCourse;
    private javax.swing.JButton addEmployee;
    private javax.swing.JButton addRoom;
    private javax.swing.JButton addRoomToBuilding;
    private javax.swing.JButton addSchedule;
    private javax.swing.JButton addShift;
    private javax.swing.JButton addTeacher;
    private javax.swing.JButton addTravelTime;
    private javax.swing.JTable buildingsTable;
    private javax.swing.JScrollPane buildingsTableScrollPane;
    private javax.swing.JTable coursesTable;
    private javax.swing.JScrollPane coursesTableScrollPane;
    private javax.swing.JButton editCourse;
    private javax.swing.JButton editEmployee;
    private javax.swing.JButton editRoom;
    private javax.swing.JButton editSchedule;
    private javax.swing.JButton editShift;
    private javax.swing.JButton editTeacher;
    private javax.swing.JButton editTravelTime;
    private javax.swing.JTable employeeTable;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTabbedPane jTabbedPane3;
    private javax.swing.JMenu mainMenu;
    private javax.swing.JMenuBar mainMenuBar;
    private javax.swing.JMenuItem menuFileExit;
    private javax.swing.JMenu menuFileNew;
    private javax.swing.JMenuItem menuFileNewCollege;
    private javax.swing.JMenuItem menuFileNewShift;
    private javax.swing.JMenuItem menuFileOpen;
    private javax.swing.JMenuItem menuFileSave;
    private javax.swing.JMenuItem menuFileSaveAs;
    private javax.swing.JTable scheduleTable;
    private javax.swing.JScrollPane scheduleTableScrollPane;
    private javax.swing.JTable shiftTable;
    private javax.swing.JTabbedPane tabPane;
    private javax.swing.JPanel tabPanel1;
    private javax.swing.JPanel tabPanel2;
    private javax.swing.JPanel tabPanel3;
    private javax.swing.JPanel tabPanel4;
    private javax.swing.JPanel tabPanel5;
    private javax.swing.JPanel tabPanel6;
    private javax.swing.JPanel tabPanel7;
    private javax.swing.JMenuItem tableClear;
    private javax.swing.JMenuItem tableDelete;
    private javax.swing.JMenuItem tableExport;
    private javax.swing.JMenuItem tableImport;
    private javax.swing.JMenuItem tableInsert;
    private javax.swing.JMenu tableMenu;
    private javax.swing.JTable teachersTable;
    private javax.swing.JScrollPane teachersTableScrollPane;
    private javax.swing.JMenuItem toolsGenerate;
    private javax.swing.JMenu toolsMenu;
    private javax.swing.JMenuItem toolsValidate;
    private javax.swing.JTable travelTimeTable;
    // End of variables declaration//GEN-END:variables
    final JFileChooser fc = new JFileChooser();
    File currentFile = null;
}
