package org.leedberg.cotiro.shiftbased;
import java.util.Iterator;

import org.leedberg.cotiro.EmployeeScheduleDocument;
import org.leedberg.cotiro.VariableList;
import org.leedberg.cotiro.EmployeeScheduleDocument.EmployeeSchedule;
import org.leedberg.cotiro.EmployeeScheduleDocument.EmployeeSchedule.Need;

/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class BuildingNeedList extends VariableList  
{
	public Object clone() {		
		BuildingNeedList l = new BuildingNeedList();
		
		for (int i=0; i < this.size(); i++) {
			BuildingNeed curElem = (BuildingNeed)this.get(i);			
			curElem = (BuildingNeed)curElem.clone();			
			l.add(curElem);
		}
		return l;
	}
	
	public String toString() {
		String retVal = "";
		Iterator i = iterator();
		while (i.hasNext()) {
			BuildingNeed c = (BuildingNeed)i.next();
			retVal += c.toString();
			retVal += "\n-------------------------------------------\n";
		}
		
		return retVal;
	}
	

	public EmployeeScheduleDocument getXmlBean() {
		EmployeeScheduleDocument doc = EmployeeScheduleDocument.Factory.newInstance();
		
		EmployeeSchedule schedule = doc.addNewEmployeeSchedule();
		
		Iterator i = iterator();
		
		while (i.hasNext()) {
			BuildingNeed bn = (BuildingNeed)i.next();
			
			Need xmlNeed = schedule.addNewNeed();
			bn.setXmlBean(xmlNeed);
		}
		return doc;
	} 
}



