package org.leedberg.cotiro.shiftbased;

import java.util.HashMap;
/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class TravelTimeStore {
	HashMap travelTimes;
	
	public TravelTimeStore() {
		travelTimes = new HashMap();
	}
	
	public void storeTravelTime(String location1, String location2, int time) {
		// travelTimes is a hashmap, where each building name maps to another HashMap.
		// the second hashmap maps 2nd building names, to an integer, which is the distance
		// between the two.   this way you can look up by either building name
		HashMap hm1 = (HashMap) travelTimes.get(location1);
		if (hm1 == null) {
			hm1 = new HashMap();
			travelTimes.put(location1, hm1);
		}

		hm1.put(location2, Integer.valueOf(time));

		HashMap hm2 = (HashMap) travelTimes.get(location2);
		if (hm2 == null) {
			hm2 = new HashMap();
			travelTimes.put(location2, hm2);

		}
		hm2.put(location1, Integer.valueOf(time));
	}
	
	public int getTravelTime(String location1, String location2) {
		HashMap tt1 = (HashMap)travelTimes.get(location1);
		
		if (tt1 == null) {
			return 0;
		}
		
		Integer tt = (Integer)tt1.get(location2);
			
		if (tt == null) {
			return 0;
		}
		
		return tt.intValue();
		
	}
}
