package org.leedberg.cotiro.shiftbased.constraints;

import org.leedberg.cotiro.Constraint;
import org.leedberg.cotiro.CotiroDocument.Cotiro.Employees.Employee.Skill;
import org.leedberg.cotiro.SoftSetting;
import org.leedberg.cotiro.VariableList;
import org.leedberg.cotiro.shiftbased.BuildingNeed;
import org.leedberg.cotiro.shiftbased.ScheduleEmployee;
/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class EmployeeSkillConstraint extends Constraint {
	public EmployeeSkillConstraint(String buildingNeedId, String skill, SoftSetting soft) {
		super(buildingNeedId, skill, soft.useSoft(false));
	}

	@Override
	public boolean satisfied(VariableList vars) {

		
		
		BuildingNeed bn = (BuildingNeed)vars.getVariable((String)this.A);
		String skillNeeded = (String)this.B;
		
		if (bn == null) {
			return true;
		} else {
			// see if bn.skill is in bn.doctor.skills
                    
                    boolean retVal = false;
                    for (Skill s : ((ScheduleEmployee)bn.getValue()).skills) {
                        if (s.getName().equals(skillNeeded)) {
                            retVal = true;
                        }
                    }
               
			return retVal;
		}
	}

	@Override
	public String toString() {
		return "BuildingNeed with ID = " + this.A + " must have a doctor with skill " + this.B;
	}
	
	public boolean isUnary() {
		// this constraint is unary, it only depends on this one variables
		return true;
	}
}
