package org.leedberg.cotiro.shiftbased.constraints;

import org.leedberg.cotiro.Constraint;
import org.leedberg.cotiro.SoftSetting;
import org.leedberg.cotiro.VariableList;
import org.leedberg.cotiro.shiftbased.BuildingNeed;
/*
Cotiro 0.6.5
College Time and Room Scheduler Using Constraint Satisfaction
Copyright (C) 2003 - 2007, Gregory G. Leedberg

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
public class NotSameEmployeeConstraint extends Constraint {

	public NotSameEmployeeConstraint(String bnId1, String bnId2, SoftSetting soft) {
		super(bnId1, bnId2, soft.useSoft(false));
	}
	
	@Override
	public boolean satisfied(VariableList vars) {
	
		
		
		BuildingNeed bn1=(BuildingNeed)vars.getVariable((String)A);		
		BuildingNeed bn2 = (BuildingNeed)vars.getVariable((String)B);
		
		if (bn1 == null || bn2 == null) {
			// bn is not in list, so no conflict can exist			
			return true;
		}
		else {
			return !(bn1.getValue().equals(bn2.getValue()));
		}	
	}

	@Override
	public String toString() {
		return "BuildingNeed " + A + " cannot have the same doctor as buildingNeed " + B;
	}

}
