/*
 * ShiftLimitConstraint.java
 *
 * Created on October 19, 2007, 4:28 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.leedberg.cotiro.shiftbased.constraints;

import org.leedberg.cotiro.Constraint;
import org.leedberg.cotiro.SoftSetting;
import org.leedberg.cotiro.VariableList;
import org.leedberg.cotiro.shiftbased.BuildingNeed;
import org.leedberg.cotiro.shiftbased.ScheduleEmployee;

/**
 *
 * @author Greg
 * This constraint makes sure that an employee is not 
 */
public class ShiftLimitConstraint extends Constraint{
    private int limit;
    
    /** Creates a new instance of ShiftLimitConstraint */
    public ShiftLimitConstraint(String employee, String skill, int limit, SoftSetting soft) {
        super(employee, skill, soft.useSoft(false));
        this.limit = limit;
    }
    
    public boolean satisfied(VariableList vars) {
        int count = 0;
        // Iterate over all assigned vars
        for (Object o : vars) {
            BuildingNeed bn = (BuildingNeed)o;
            ScheduleEmployee se = (ScheduleEmployee)bn.getValue();
            
            // If any vars have this employee assigned, check to see if it is because of this skill
            if (se.name.equals(this.A)) {
                if (bn.skillNeeded.equals(B)) {
                    // If it is, keep a count... as soon as we exceed limit, return false;                    
                    count++;
                    
                    if (count > limit) {
                        return false;
                    }
                }
            }
            
        }
        return true;
    }
    public String toString() {

        return "ShiftLimitConstraint: " + A + " should not be assigned to " + B + " more than " + limit + " times";
    }
    
}
